



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>手把手教你全家桶之React(三)--完结篇</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">手把手教你全家桶之React(三)--完结篇</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 08:14:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前言</h2>
<p>本篇主要是讲一些全家桶的优化与完善，基础功能<a href="https://www.cnblogs.com/zhoulin-circle/p/9012729.html" rel="external nofollow noreferrer">上一篇</a>已经讲得差不多了。直接开始：</p>
<h2>Source Maps</h2>
<p>当javaScript抛出异常时，我们会很想知道它发生在哪个文件的哪一行。但是webpack 总是将文件输出为一个或多个bundle，我们对错误的追踪很不方便。Source maps试图解决这一个问题，我们只需要改变一下配置项即可。<br /><br />
在webpack.dev.config.js中加入：</p>
<pre class="prettyprint linenums"><code>devtool:&quot;inline-source-map&quot;<br />
</code></pre>
<h2>css编译</h2>
<ul><li>这里以less-loader为例，先安装</li></ul>
<ol><li>less-loader 是组件中可以引入less后缀的文件</li>
<li>css-loader 是使css文件可以用@import和url(...)的方法实现require；</li>
<li>style-loader 使计算后的样式加入到页面中。</li></ol>
<pre class="prettyprint linenums"><code>npm install --save-dev less-loader less css-loader style-loader<br />
</code></pre>
<ul><li>配置webpack.dev.config.js文件</li></ul>
<pre class="prettyprint linenums"><code> module:{<br />
        rules:[<br />
            {<br />
                test:/\.js$/,<br />
                use:['babel-loader?cacheDirectory=true'],<br />
                include:path.join(__dirname,'src')<br />
            },{<br />
                test:/\.less$/,<br />
                use:[<br />
                    'style-loader',<br />
                    {loader:'css-loader',options:{importLoaders:1}},<br />
                    'less-loader'<br />
                ]<br />
            }<br />
        ]<br />
    },<br />
</code></pre>
<p>测试下</p>
<pre class="prettyprint linenums"><code>cd src/pages/Home<br />
touch Home.less<br />
</code></pre>
<p>打开 Home.less</p>
<pre class="prettyprint linenums"><code>.wrap{<br />
    width:300px;<br />
    height:300px;<br />
    background:red;<br />
    &amp; .content{<br />
        width:200px;<br />
        height:200px;<br />
        margin:auto;<br />
        background:yellow;<br />
    }<br />
 }<br />
</code></pre>
<p>在Home.js中引入，并添加class</p>
<pre class="prettyprint linenums"><code>import './Home.less'<br />
...<br />
  render(){<br />
        return(<br />
            &lt;div&gt;<br />
                &lt;h1&gt;当前共点击次数为：{this.state.count}&lt;/h1&gt;<br />
                &lt;button onClick={()=&gt; this._test()}&gt;点击我！&lt;/button&gt;<br />
                &lt;div className=&quot;wrap&quot;&gt;<br />
                    &lt;div className=&quot;content&quot;&gt;&lt;/div&gt;<br />
                &lt;/div&gt;<br />
            &lt;/div&gt;<br />
        )<br />
    }<br />
</code></pre>
<p>因为添加了新的依赖，我们重新跑一次npm run start,效果如图<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531102558121-335459223.png"></p>
<h2>图片编译</h2>
<p>先进行一个测试,打开src/Pages/UserInfo/UserInfo.js</p>
<pre class="prettyprint linenums"><code>import imgSrc from '../../../public/image/react15.png'<br />
    ...<br />
    &lt;h2&gt;个人资料&lt;/h2&gt;<br />
    &lt;img src={imgSrc}/&gt;<br />
</code></pre>
<p>运行后，页面报错<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531102626842-729613516.png"></p>
<p>出现这个错误是因为打包后的文件找不到我们之前写好的相对路径。对此，我们可以用如下方式解决。<br /><br />
首先我们要安装两个依赖：</p>
<ul><li>file-loader 当我们写样式比如背景图片，我们的路径是相对于当前文件的，但webpack最终会打包成一个文件。打包后的相对路径会找不到对应文件。这时，file-loader可以帮我们找到正确的文件路径。</li>
<li>url-loader 如果图片过多，会增加过多的http请求，url-loader提示图片base64编码服务，设定limit参数，小于设置值的图片会被转为一串字符，只需将字符打包到文件中，就能访问图片了。</li></ul>
<pre class="prettyprint linenums"><code>npm install --save-dev url-loader file-loader<br />
</code></pre>
<p>在webpack.dev.config.js增加配置</p>
<pre class="prettyprint linenums"><code>module:{<br />
        rules:[<br />
            ...<br />
            {<br />
                test:/\.(png|jpg|gif)$/,<br />
                use:[{<br />
                    loader:'url-loader',<br />
                    options:{<br />
                        // 设置为小于8K的大小<br />
                        limit:8192<br />
                    }<br />
                }]<br />
            }<br />
        ]<br />
}<br />
</code></pre>
<p>配置成功后，我们重新运行npm run start(因为新加了依赖要重新跑一次服务)，看下效果（PS：盗用大幂幂的照片<sup>_</sup>）<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531102644506-287447210.png"></p>
<h2>按需加载</h2>
<p>我们打包后，页面统一生成bundle.js，当我们进入Home页面时，因为加载的文件过多会导致页面慢。我们想要达到跳转到对应页面时按需加载文件的效果，就需要用到bundle-loader。</p>
<ul><li>安装</li></ul>
<pre class="prettyprint linenums"><code>npm install bundle-loader --save<br />
</code></pre>
<ul><li>在router下新建Bundle.js</li></ul>
<pre class="prettyprint linenums"><code>cd src/router<br />
touch Bundle.js<br />
</code></pre>
<p>打开Bundle.js，根据<a href="https://reacttraining.com/react-router/web/guides/code-splitting" rel="external nofollow noreferrer">示例</a></p>
<pre class="prettyprint linenums"><code>import React,{Component} from 'react'<br />
class Bundle extends Component{<br />
    state={<br />
        mod:null<br />
    };<br />
    componentWillMount(){<br />
        this.load(this.props)<br />
    }<br />
    componentWillReceiveProps(nextProps){<br />
        if(nextProps.load !== this.props.load){<br />
            this.load(nextProps)<br />
        }<br />
    }<br />
    load(props){<br />
        this.setState({<br />
            mod:null<br />
        });<br />
        props.load((mod)=&gt;{<br />
            this.setState({<br />
                mod:mod.default ? mod.default : mod<br />
            })<br />
        })<br />
    }<br />
    render(){<br />
        return this.props.children(this.state.mod)<br />
    }<br />
}<br />
export default Bundle;<br />
</code></pre>
<ul><li>路由配置改造，src/router/router.js</li></ul>
<pre class="prettyprint linenums"><code>import React from 'react';<br />
import {BrowserRouter as Router,Route,Switch,Link} from 'react-router-dom';

import Home from 'bundle-loader?lazy&amp;name=home!pages/Home/Home';<br />
import About from 'bundle-loader?lazy&amp;name=page1!pages/About/About';<br />
import Counter from 'bundle-loader?lazy&amp;name=counter!pages/Counter/Counter';<br />
import UserInfo from 'bundle-loader?lazy&amp;name=userInfo!pages/UserInfo/UserInfo';<br />
const Loading = function(){<br />
    return &lt;div&gt;Loading...&lt;/div&gt;<br />
};<br />
const createComponent = (component) =&gt; (props) =&gt; (<br />
    &lt;Bundle load={component}&gt;<br />
        {<br />
            (Componet) =&gt; Component ? &lt;Component {...props} /&gt; : &lt;Loading/&gt;<br />
        }<br />
    &lt;/Bundle&gt;<br />
);<br />
const getRouter=()=&gt;(<br />
    &lt;Router&gt;<br />
        &lt;div&gt;<br />
            &lt;ul&gt;<br />
                &lt;li&gt;&lt;Link to=&quot;/&quot;&gt;Home&lt;/Link&gt;&lt;/li&gt;<br />
                &lt;li&gt;&lt;Link to=&quot;/about&quot;&gt;About&lt;/Link&gt;&lt;/li&gt;<br />
                &lt;li&gt;&lt;Link to=&quot;counter&quot;&gt;Counter&lt;/Link&gt;&lt;/li&gt;<br />
                &lt;li&gt;&lt;Link to=&quot;userinfo&quot;&gt;UserInfo&lt;/Link&gt;&lt;/li&gt;<br />
            &lt;/ul&gt;

            &lt;Switch&gt;<br />
                &lt;Route exact path=&quot;/&quot; component={createComponent(Home)}/&gt;<br />
                &lt;Route path=&quot;/about&quot; component={createComponent(About)}/&gt;<br />
                &lt;Route path=&quot;/counter&quot; component={createComponent(Counter)}/&gt;<br />
                &lt;Route path=&quot;/userinfo&quot; component={createComponent(UserInfo)}/&gt;<br />
            &lt;/Switch&gt;<br />
        &lt;/div&gt;<br />
    &lt;/Router&gt;

);<br />
export default getRouter;<br />
</code></pre>
<ul><li>修改webpack.dev.config.js配置，使打包输出的文件名对应</li></ul>
<pre class="prettyprint linenums"><code>output:{<br />
    path:path.join(__dirname,'./dist'),<br />
    filename:'bundle.js',<br />
    chunkFilename:'[name].js'<br />
}<br />
</code></pre>
<p>运行npm run start 效果如图</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103313642-98683728.gif"></p>
<h2>缓存</h2>
<p>按需加载文件的进阶优化则是文件缓存。缓存我们要解决以下两个问题：</p>
<ol><li>当用户首次访问Home.js时，进行文件的加载，第二次访问时再进行同样文件的加载吗？</li>
<li>当文件做了缓存时，我们如果有改动代码，重新打包，我们要如何更新缓存的文件？<br /><br />
问题1在浏览器中已经对静态资源文件做了缓存，我们主要解决问题二。<br /><br />
日常开发中，我们是通过打包修改文件名（比如加hash），使客户端能识别新的文件，重新加载。<br /><br />
打开webpack.dev.config.js</li></ol>
<pre class="prettyprint linenums"><code>output:{<br />
    path:path.join(__dirname,'./dist'),<br />
    filename:'[name].[hash].js',<br />
    chunkFilename:'[name].[chunkhash].js'<br />
}<br />
</code></pre>
<p>我们可以看到编译后的文件名已经变了<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103438879-982169481.png"></p>
<p>由于我们在dist/index.html中引用的还是bundle.js，所以我们要改成每次编译后自动插入到index.html中，可以用到HtmlWebpackPlugin。</p>
<ul><li>安装</li></ul>
<pre class="prettyprint linenums"><code>npm install html-webpack-plugin --save-dev<br />
</code></pre>
<ul><li>新建入口模板文件index.html</li></ul>
<pre class="prettyprint linenums"><code>cd src<br />
touch index.html<br />
</code></pre>
<ul><li>打开index.html</li></ul>
<pre class="prettyprint linenums"><code>&lt;!DOCTYPE html&gt;<br />
&lt;html lang=&quot;en&quot;&gt;<br />
&lt;head&gt;<br />
    &lt;meta charset=&quot;UTF-8&quot;&gt;<br />
    &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width, initial-scale=1.0&quot;&gt;<br />
    &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;ie=edge&quot;&gt;<br />
    &lt;title&gt;Document&lt;/title&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
    &lt;div id=&quot;app&quot;&gt;&lt;/div&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;<br />
</code></pre>
<ul><li>修改webpack.dev.config.js配置文件</li></ul>
<pre class="prettyprint linenums"><code>var HtmlWebpackPlugin=require('html-webpack-plugin');<br />
...<br />
plugins:[new HtmlWebpackPlugin({<br />
    filename:'index.html',<br />
    template:path.join(__dirname,'src/index.html')<br />
})],<br />
</code></pre>
<p>此时删掉之前的dist/index.html,运行npm run start访问正常。</p>
<h2>公共代码提取</h2>
<p>我们打包生成的文件js文件中，都包含了react,redux,react-router这样的代码。然而这些依赖代码我们在很多文件都引用了，而不需要它自动更新。所以我们可以把这些公共代码提取出来。<br /><br />
我们根据<a href="https://webpack.docschina.org/guides/caching/#%E6%8F%90%E5%8F%96%E6%A8%A1%E6%9D%BF-extracting-boilerplate-" rel="external nofollow noreferrer">教程</a>配置。</p>
<ul><li>打开webpack.dev.config.js</li></ul>
<pre class="prettyprint linenums"><code>var webpack=require('webpack');<br />
module.exports={<br />
    entry:{<br />
        app:[<br />
            'react-hot-loader/patch',<br />
            path.join(__dirname,'src/index.js')<br />
        ],<br />
        vendor:['react','react-router-dom','redux','react-dom','react-redux']<br />
    },<br />
    plugins:[<br />
        ...<br />
        new webpack.optimize.CommonsChunkPlugin({<br />
            name:'vendor'<br />
        })<br />
    ]<br />
}<br />
</code></pre>
<p>重新运行，打包文件如下<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103517851-2128033470.png"></p>
<p>可以发现app.[hash].js和vendor.[hash].js生成的hash是一样的。也就意味着如果代码有改动app.[hash].js与vendor.[hash].js都会同时改变。然后vendor里的内容我们不希望它更新。根据文档，我要在webpack里还要配置<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103530928-2132609408.png"></p>
<p>应用到我们项目应该</p>
<pre class="prettyprint linenums"><code>output:{<br />
    path:path.join(__dirname,'./dist'),<br />
    filename:'[name].[chunkhash].js',<br />
    chunkFilename:'[name].[chunkhash].js'<br />
}<br />
</code></pre>
<p>再次运行，发现报错，webpack-dev-server --hot 不兼容chunkhash<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103553735-1842336836.png"></p>
<p>解决这个问题，我们要先区分生产环境与开发环境的区别。所以，上面的问题先留一下，我们先来构建生产环境的配置。</p>
<h2>生产环境构建</h2>
<p>生产环境与开发环境的区别往往体现在目标差异大。开发环境我们要配置的东西很多，要求实时加裁，热更新模块等。但生产环境要求较小，更关注小的bundle，更轻量的Source map，更高效的加载时间等。</p>
<ul><li>首先创建配置文件</li></ul>
<pre class="prettyprint linenums"><code>touch webpack.config.js<br />
</code></pre>
<ul><li>将之前webpack.dev.config.js的内容复制到webpack.config.js中，删除一些和开发环境有关的几点：</li></ul>
<ol><li>webpack-dev-server相关内容</li>
<li>devtool的值改成 cheap-module-source-map</li>
<li>输出文件名增加字符改为chunkhash,原本的webpack.dev.config.js改回为hash<br /><br />
根据以上几点，webpack.config.js内容如下：</li></ol>
<pre class="prettyprint linenums"><code>var path=require('path');<br />
var HtmlWebpackPlugin=require('html-webpack-plugin');<br />
var webpack=require('webpack');<br />
module.exports={<br />
    // 入口文件指向src/index.js<br />
    entry:{<br />
        app:[<br />
            'react-hot-loader/patch',<br />
            path.join(__dirname,'src/index.js')<br />
        ],<br />
        vendor:['react','react-router-dom','redux','react-dom','react-redux']<br />
    },<br />
    //打包后的文件到当前目录下的dist文件夹，名为bundle.js<br />
    output:{<br />
        path:path.join(__dirname,'./dist'),<br />
        filename:'[name].[chunkhash].js',<br />
        chunkFilename:'[name].[chunkhash].js'<br />
    },<br />
    module:{<br />
        rules:[<br />
            {<br />
                test:/\.js$/,<br />
                use:['babel-loader?cacheDirectory=true'],<br />
                include:path.join(__dirname,'src')<br />
            },{<br />
                test:/\.less$/,<br />
                use:[<br />
                    'style-loader',<br />
                    {loader:'css-loader',options:{importLoaders:1}},<br />
                    { loader: 'less-loader', options: { strictMath: true, noIeCompat: true } }<br />
                ]<br />
            },<br />
            {<br />
                test:/\.(png|jpg|gif)$/,<br />
                use:[{<br />
                    loader:'url-loader',<br />
                    options:{<br />
                        limit:8192<br />
                    }<br />
                }]<br />
            }

        ]<br />
    },<br />
    plugins:[<br />
        new HtmlWebpackPlugin({<br />
            filename:'index.html',<br />
            template:path.join(__dirname,'src/index.html')<br />
        }),<br />
        new webpack.optimize.CommonsChunkPlugin({<br />
            name:'vendor'<br />
        })<br />
    ],<br />
    devtool:&quot;cheap-module-source-map&quot;,<br />
    resolve:{<br />
        alias:{<br />
            pages:path.join(__dirname,'src/pages'),<br />
            components:path.join(__dirname,'src/components'),<br />
            router:path.join(__dirname,'src/router'),<br />
            actions:path.join(__dirname,'src/redux/actions'),<br />
            reducers:path.join(__dirname,'src/redux/reducers'),<br />
            // redux:path.join(__dirname,'src/redux') 与模块重名<br />
        }<br />
    }<br />
};<br />
</code></pre>
<ul><li>在package.json中增加build打包命令，指定配置文件。</li></ul>
<pre class="prettyprint linenums"><code> &quot;scripts&quot;: {<br />
    &quot;test&quot;: &quot;echo \&quot;Error: no test specified\&quot; &amp;&amp; exit 1&quot;,<br />
    &quot;build&quot;: &quot;webpack --config webpack.config.js&quot;,<br />
    &quot;start&quot;: &quot;webpack-dev-server --config webpack.dev.config.js --color --progress --hot&quot;<br />
  },<br />
</code></pre>
<p>运行一次打包命令 npm run build，文件名支持了chunkhash.<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103616364-1886966696.png"></p>
<p>虽然文件名不同了，但是改变代码重新打包会发现app.[hash].js和vendor.[chunkhash].js一样都更新了名字，这不就和没拆分是一样的吗？<br /><br />
别着急，看官网介绍<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103631632-1294479306.png"></p>
<p><b>注意mainfest与vendor的顺序不能错哦</b></p>
<ul><li>打开webpack.config.js</li></ul>
<pre class="prettyprint linenums"><code> plugins:[<br />
        new HtmlWebpackPlugin({<br />
            filename:'index.html',<br />
            template:path.join(__dirname,'src/index.html')<br />
        }),<br />
        new webpack.HashedModuleIdsPlugin(),<br />
        new webpack.optimize.CommonsChunkPlugin({<br />
            name:'vendor'<br />
        }),<br />
        new webpack.optimize.CommonsChunkPlugin({<br />
            name:'mainfest'<br />
        })<br />
    ]<br />
</code></pre>
<p>当我们构建了基础的生产环境配置后，我们可以增加指定环境配置，根据process.env.NODE_ENV环境变量关联，让<a href="http://www.css88.com/doc/webpack/guides/author-libraries/" rel="external nofollow noreferrer">library</a>中应该引用哪些内容。例如，当不处于生产环境中时，library可能会添加额外的日志log和test。当使用 process.env.NODE_ENV === 'production' 时，一些 library 可能针对具体用户的环境进行代码优化，从而删除或添加一些重要代码。</p>
<ul><li>打开webpack.config.js</li></ul>
<pre class="prettyprint linenums"><code>module.exports={<br />
    plugins:[<br />
        ...<br />
        new webpack.DefinePlugin({<br />
            'process.env':{<br />
                'NODE_ENV':JSON.stringify('production')<br />
            }<br />
        })<br />
    ]<br />
}<br />
</code></pre>
<h2>打包优化</h2>
<h4>文件压缩</h4>
<p>webpack使用UglifyJSPlugin来压缩打包后生成的文件。</p>
<ul><li>安装</li></ul>
<pre class="prettyprint linenums"><code>npm install uglifyjs-webpack-plugin --save-dev<br />
</code></pre>
<ul><li>打开webpack.config.js进行配置</li></ul>
<pre class="prettyprint linenums"><code>const UglifyJSPlugin=require('uglifyjs-webpack-plugin')<br />
module.exports={<br />
    plugins:[<br />
        ...<br />
        new UglifyJSPlugin()<br />
    ]<br />
}<br />
</code></pre>
<p>运行npm run build有没有发现打包的文件小了好多<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103650223-1394571500.png"></p>
<h4>清理dist文件</h4>
<p>每次打包dist都会多好多文件混合在里面，我们应该清掉之前打包的文件，只留下当前打包后的文件。我们用到clean-webpack-plugin</p>
<ul><li>安装</li></ul>
<pre class="prettyprint linenums"><code>npm install clean-webpack-plugin --save-dev<br />
</code></pre>
<ul><li>打开webpack.config.js来配置</li></ul>
<pre class="prettyprint linenums"><code>const CleanWebpackPlugin=require('clean-webpack-plugin');<br />
...<br />
plugins:[<br />
    new CleanWebpackPlugin(['dist'])<br />
]<br />
</code></pre>
<p>现在试试打包一下，每次是不是都是直接覆盖整个文件。虽然api文件也被清掉了，但是没关系，那只是用来测试的。</p>
<h4>静态文件的基本路径</h4>
<p>当我们打包后，静态文件没办法定位到静态服务器，我们需要在webpack.config.js中配置</p>
<pre class="prettyprint linenums"><code>output:{<br />
    ...<br />
    publicPath:'/'<br />
}<br />
</code></pre>
<h4>css打包分离</h4>
<p>如果我要要将打包到js的css内容抽出来单独成css文件，我们可以使用extract-text-webpack-plugin.</p>
<ul><li>安装</li></ul>
<pre class="prettyprint linenums"><code>npm install extract-text-webpack-plugin --save-dev<br />
</code></pre>
<ul><li>打开webpack.config.js进行配置</li></ul>
<pre class="prettyprint linenums"><code>const ExtractTextPlugin=require(&quot;extract-text-webpack-plugin&quot;);<br />
module.exports={<br />
    module:{<br />
        rules:[<br />
            ...<br />
            {<br />
                test:/\.(css|less)$/,<br />
                use:ExtractTextPlugin.extract({<br />
                    fallback:&quot;style-loader&quot;,<br />
                    use:&quot;css-loader&quot;<br />
                })<br />
            }<br />
        ]<br />
    },<br />
    plugins:[<br />
        ...<br />
        new ExtractTextPlugin({<br />
            filename:'[name].[contenthash:5].css',<br />
            allChunks:true<br />
        })<br />
    ]<br />
}<br />
</code></pre>
<p>我们可以增加一些css文件引用，来测试下。由于我们之前的示例是用less来写的样式，那么我们加上less的<a href="https://github.com/webpack-contrib/extract-text-webpack-plugin" rel="external nofollow noreferrer">配置</a>，使之生成独立文件。<br /><br />
修改刚刚的配置项：</p>
<pre class="prettyprint linenums"><code>module.exports={<br />
    module:{<br />
        rules:[<br />
            ...<br />
            {<br />
                test:/\.(css|less)$/,<br />
                use:ExtractTextPlugin.extract({<br />
                    fallback:&quot;style-loader&quot;,<br />
                    use:[&quot;css-loader&quot;,&quot;less-loader&quot;]<br />
                })<br />
            }<br />
        ]<br />
    },<br />
}<br />
</code></pre>
<p>重新打包，就能看到被生成的css文件啦<br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1138408/201805/1138408-20180531103711852-281170242.png"></p>
<h2>axios</h2>
<ul><li>安装axios</li></ul>
<pre class="prettyprint linenums"><code>npm install --save axios<br />
</code></pre>
<ul><li>然后简化之前写的userInfo的action,修改redux/actions/userInfo.js</li></ul>
<pre class="prettyprint linenums"><code>export const GET_USERINFO_REQUEST=&quot;userInfo/GET_USERINFO_REQUEST&quot;;<br />
export const GET_USERINFO_SUCCESS=&quot;userInfo/GET_USERINFO_SUCCESS&quot;;<br />
export const GET_USERINFO_FAIL=&quot;userInfo/GET_USERINFO_FAIL&quot;;

export function getUserInfo(){<br />
    return{<br />
        types:[GET_USERINFO_REQUEST,GET_USERINFO_SUCCESS,GET_USERINFO_FAIL],<br />
        promise:client =&gt; client.get('/api/userInfo.json')<br />
    }<br />
}<br />
</code></pre>
<p>其中dispath(getUserInfo())后，是通过redux的中间件来处理的。为了弄清楚，我们自己来写一个。</p>
<h4>自定义Middleware</h4>
<ul><li>清理逻辑</li></ul>
<ol><li>发起请求前 dispatch REQUEST;</li>
<li>请求成功后 dispatch SUCESS,再执行callback;</li>
<li>请求失败后 dispatch FAIL。</li></ol>
<ul><li>创建基本文件</li></ul>
<pre class="prettyprint linenums"><code>cd src/redux<br />
mkdir middleware &amp;&amp; cd middleware<br />
touch promiseMiddleware.js<br />
</code></pre>
<ul><li>定义promiseMiddleware.js的内容</li></ul>
<pre class="prettyprint linenums"><code>import axios from 'axios';<br />
export default store =&gt; next =&gt;action =&gt;{<br />
    const {dispatch,getState}=store;<br />
    // 如果dispatch传来的是一个function,则跳过<br />
    if(typeof action === 'function'){<br />
        action(dispatch,getState);<br />
        return ;<br />
    }<br />
    // 解析action<br />
    const {<br />
        promise,<br />
        types,<br />
        afterSuccess,<br />
        ...rest<br />
    }=action;<br />
    // 如果不是异步请求则直接跳转下一步<br />
    if(!action.promise){<br />
        return next(action);<br />
    }<br />
    // 解析types<br />
    const [REQUEST,SUCCESS,FAILURE]=types;<br />
    // 发送action<br />
    next({<br />
        ...rest,<br />
        type:REQUEST<br />
    });<br />
    // 成功<br />
    const onFulfilled = result=&gt;{<br />
        next({<br />
            ...rest,<br />
            result,<br />
            type:SUCCESS<br />
        });<br />
        if(afterSuccess){<br />
            afterSuccess(dispatch,getState,result);<br />
        }<br />
    };<br />
    // 失败<br />
    const onRejected=error=&gt;{<br />
        next({<br />
            ...rest,<br />
            error,<br />
            type:FAILURE<br />
        });<br />
    };<br />
    return promise(axios).then(onFulfilled,onRejected).catch(error=&gt;{<br />
        console.error('MIDDLEWARE ERROR:',error);<br />
        onRejected(error)<br />
    })<br />
}<br />
</code></pre>
<ul><li>在src/redux/store.js中应用中间件</li></ul>
<pre class="prettyprint linenums"><code>import {createStore,applyMiddleware} from 'redux';<br />
import combineReducers from './reducers.js';<br />
// import thunkMiddleware from 'redux-thunk';<br />
// let store = createStore(combineReducers,applyMiddleware(thunkMiddleware));

import promiseMiddleware from './middleware/promiseMiddleware';<br />
let store = createStore(combineReducers,applyMiddleware(promiseMiddleware));

export default store;<br />
</code></pre>
<ul><li>最后修改src/redux/reducers/userInfo.js<br /><br />
因为是当action请求成功，我们在中间件会自动加上一个result字段来存结果。</li></ul>
<pre class="prettyprint linenums"><code>export default function reducer(state=initState,action){<br />
    switch(action.type){<br />
        ...<br />
        case GET_USERINFO_SUCCESS:<br />
            return{<br />
                ...state,<br />
                isLoading:false,<br />
                userInfo:action.result.data,<br />
                errMsg:''<br />
            }<br />
    }<br />
}<br />
</code></pre>
<p>我们重启npm run start ,访问userInfo接口是不是成功啦！<br /><br />
好啦，先写到这吧，如果还有细节完善会在源码上更新。<a href="https://github.com/zhoulin-cirlce/react-Buckets" rel="external nofollow noreferrer">源码地址</a>，欢迎star和issues。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1jxzqg.html">T-SQL学习记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jz4x48.html">【转】OBJECT&lowbar;ID和DATA&lowbar;OBJECT&lowbar;ID的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7o6ve8.html">在Hibernate框架中详谈一级缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8odjveq.html">PHP5&period;6启动失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlp7z69.html">【java手记】------------------------java中转发和重定向区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7nx1q.html">编译过程中，termcap&period;h      文件找不到路径     licli&period;a终于生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd04dgq.html">WCF 下的windows服务的安装卸载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnmp3d8.html">JVM调优实践-Tomcat调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6lel9.html">SKPhysicsBody类</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oe33y9.html">BZOJ1697&colon; &lbrack;Usaco2007 Feb&rsqb;Cow Sorting牛排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv12w0yq.html">jquery 实现飘落效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mjmrn8.html">ural1553 Caves and Tunnels</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojm3dxq.html">Web系统中Mic设备的应用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zommlnq.html">PHP中的面向对象思想</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rx2o58.html">LeetCode 784 Letter Case Permutation 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1re3p08.html">MicrosoftSQLServer数据库定时备份（备份计划）的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em0zkj9.html">MySQL锁定状态查看相关命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15e009.html">使用Python生成双色球号码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4mwp1q.html">2018软工实践&mdash;Alpha冲刺&lpar;3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koy473q.html">32&period;Longest Valid Parentheses---dp</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kjjl0r9.html">vue内置指令与自定义指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlll2o0q.html">Kubernetes 中的核心组件与基本对象概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv22ojx9.html">mysql 开发基础系列8 表的存储引擎</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e446rj9.html">使用IntelliJ IDEA新建Java Web后端resfulAPI模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv22pw19.html">&lbrack;转&rsqb;java中作用域public private protected 以及不写的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyyjvjq.html">nginx proxy&lowbar;pass 代理域名</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rrxdo9.html">（转）MySQL join语法解析与性能分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1107pq.html">Java&mdash;&mdash;static关键字</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdww2vv9.html">spark集群的简单测试和基础命令的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rrw749.html">Spring Bean的生命周期相关博客</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
